if not (Klappa) then return; end;
local _G = getfenv(0);

local Klappa = Klappa;
local config = {};

local AceOO = AceLibrary("AceOO-2.0");
local L = AceLibrary("AceLocale-2.2"):new("Klappa");

Klappa.PopUpButton = AceOO.Class(Klappa.Button);

function Klappa.PopUpButton.prototype:init(parent, idx, type, id, bar)
	Klappa.PopUpButton.super.prototype.init(self, idx, type, id, bar);
	
	config = Klappa.config.bars;
	
	self.parent = parent;
	self.isPopup = true;
	
	self:CreatePopupButton();
	self:LoadSpell();
	if(self.index == 1) then
		self:AddFuHeader()
	end
	self:AddOptions()
	
	Klappa:Debug("PopupButton: "..self.button:GetName().." created");
end

function Klappa.PopUpButton.prototype:CreatePopupButton()
	local name = "Klappa".."Bar"..self.barid..self.type.."Button"..self.index+1;
	self.button = CreateFrame("CheckButton", name, self.parent.button, "SecureAnchorUpDownTemplate,SecureActionButtonTemplate,ActionButtonTemplate");
	self.button.name = name;
	self.button:SetWidth(config[self.barid].size);
	self.button:SetHeight(config[self.barid].size);
	self.button.class = self;
	self.button.id = self.id;
	self.button.index = self.index;
	self.button:SetScript("OnEnter", function() self:ShowTooltip(self.button); end);
	self.button:SetScript("OnLeave", function() self:HideTooltip(self.button); end);
	
	self:ButtonProperties();
	self:SetAttributes();
end

function Klappa.PopUpButton.prototype:SetAttributes()
	self.button:SetAttribute("anchorchild", self.parent.frame);
	self.button:SetAttribute("showstates", tostring(self.parent.index));
	self.bar.root:SetAttribute("addchild", self.button);
end

function Klappa.PopUpButton.prototype:ChangeID(id)
	self.button.id = id;
	self:LoadSpell();
	self.button:Show();
	config[self.barid].buttons[self.parent.index].popups[self.index].id = id;
end

function Klappa.PopUpButton.prototype:UpdateLayout(isVert, isRtDn, x, y)
	Klappa:Debug("Position of "..self.button:GetName());
	Klappa:Debug("x: "..x.."  __  Y: "..y);
	
	local padding = config[self.barid].padding;
	if (isVert and isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("LEFT", self.parent.button, "RIGHT", x , y);
	elseif (isVert and not isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("RIGHT", self.parent.button, "LEFT", x , y);
	elseif (not isVert and isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("TOP", self.parent.button, "BOTTOM", x, y );
	elseif (not isVert and not isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("BOTTOM", self.parent.button, "TOP", x, y );
	end
	
	self.button:SetAlpha(config[self.barid].popupAlpha);
	self.button:SetScale(config[self.barid].popupScale);
end

function Klappa.PopUpButton.prototype:AddFuHeader()
	--local header = {
	--		["PopupsHeader"] = {
	--		type = "header",
	--	},
	--};
	--table.insert(Klappa.options.args["Bar"..self.barid].args["Main"..self.parent.index].args, header )
end

function Klappa.PopUpButton.prototype:AddOptions()
	local changeId = {
			name = L["Change ID of popup button: "]..self.index,
			desc = L["Change the ID of this popup button"],
			type = "range",
			step = 1,
			min = 1,
			max = 120,
			isPercent = false,
			get = function() return self.button.id; end,
			set = function(v) self:ChangeID(v); end			
		};
	table.insert(Klappa.options.args["Bar"..self.barid].args["Main"..self.parent.index].args, changeId )
end
